package com.ym.modulecommon.net

import android.text.TextUtils
import com.ym.modulecommon.AdConstant
import com.ym.modulecommon.AppLibraryConfig
import com.ym.modulecommon.utils.PhoneUtils
import com.ym.modulecommon.utils.AdPreference
import okhttp3.Interceptor
import okhttp3.Request
import okhttp3.logging.HttpLoggingInterceptor
import retrofit2.adapter.rxjava2.RxJava2CallAdapterFactory
import retrofit2.converter.gson.GsonConverterFactory
import java.util.concurrent.TimeUnit

/**
 * Created by gaoleichao on 2018/5/2.
 */
object ZXADClient {

    private val logInterceptor = HttpLoggingInterceptor()
    private val paramsInterceptor = Interceptor { chain ->
        val request = chain.request()
        val builder = request.url().newBuilder()
        if (request.url().toString().contains("yilan")) {
            chain.proceed(request.newBuilder().build())
        } else {
            PhoneUtils.addParam(request, builder)
            chain.proceed(request.newBuilder().url(builder.build()).build())
        }
    }

    private val headInterceptor = Interceptor { chain ->
        val request = chain.request()
        val builder = request.newBuilder()
        builder.addHeader(AdConstant.Device.aid, AdPreference.getAndroidId())
        builder.addHeader(AdConstant.Device.env, AdConstant.param.env)
        if (!TextUtils.isEmpty(AdPreference.getUserAgent())) {
            builder.addHeader("web-user-agent", AdPreference.getUserAgent())
            builder.removeHeader("User-Agent")
            builder.addHeader("User-Agent", AdPreference.getUserAgent())
        }
        val headers: Request = builder.build()
        chain.proceed(headers)
    }

    private val httpClient = okhttp3.OkHttpClient.Builder()
            .connectTimeout(10000, TimeUnit.MILLISECONDS)
            .readTimeout(10000, TimeUnit.MILLISECONDS)
            .addInterceptor(logInterceptor.apply {
                level =  if(AppLibraryConfig.NetConfig.isDebug)HttpLoggingInterceptor.Level.BODY else{HttpLoggingInterceptor.Level.NONE}
            })
            .addInterceptor(DecryptInterceptor())
            .hostnameVerifier { hostname, session ->
                true
            }
            .addInterceptor(paramsInterceptor)
            .addInterceptor(headInterceptor)
            .build()!!

    private val retrofit = retrofit2.Retrofit.Builder()
            .client(httpClient)
            .addCallAdapterFactory(RxJava2CallAdapterFactory.create())
            .addConverterFactory(GsonConverterFactory.create())
            .baseUrl(NetConfig.BASE_AD_URL)
            .build()

    val adApi by lazy { retrofit.create(ZXAdApi::class.java) }
}